/*
Created by: Nicholas Tolrud
Year: 2011
*/

import java.awt.Graphics;
import java.awt.Color;
import java.awt.geom.Point2D;

public class Vect_Circle extends Vect_Object
{
	private Point2D.Float centerPoint;
	private float radius;
	private Color color;

	public Vect_Circle(Point2D.Float centerPoint, float radius, Color color)
	{
		this.centerPoint = centerPoint;
		this.radius = radius;
		this.color = color;
		this.depth = 0;

	}
	public void draw(Graphics g, float globalX, float globalY, float zoom, int canvasWidth, int canvasHeight)
	{
		int relativeCenterX = VectorCanvas.getRelativePositionValue(globalX, zoom, centerPoint.x);
		int relativeCenterY = VectorCanvas.getRelativePositionValue(globalY, zoom, centerPoint.y);
		int relativeRadius = (int) (radius * zoom);

		if (relativeRadius > 1)
		{
			int minX = relativeCenterX - relativeRadius;
			int minY = relativeCenterY - relativeRadius;
			int maxX = relativeCenterX + relativeRadius;
			int maxY = relativeCenterY + relativeRadius;

			if (VectorCanvas.isInCanvas(canvasWidth, canvasHeight, minX, minY, maxX, maxY))
				//diameter is the radius times 2
			{
				int relativeDiameter = relativeRadius << 1;
				g.setColor(color);
				int upperLeftX = relativeCenterX - relativeRadius;
				int upperLeftY = relativeCenterY - relativeRadius;
				g.drawOval(upperLeftX, upperLeftY, relativeDiameter, relativeDiameter);
				g.fillOval(upperLeftX, upperLeftY, relativeDiameter, relativeDiameter);
			}
			}
		else if (relativeRadius >= 0)
			//only one pixel to worry about here
		{
			if (VectorCanvas.isInCanvas(canvasWidth, canvasHeight, relativeCenterX, relativeCenterY))
			{
				g.setColor(color);
				VectorCanvas.drawPoint(g, relativeCenterX, relativeCenterY);
			}
		}
	}
}
