/*
Created by: Nicholas Tolrud
Year: 2011
*/

import java.awt.Graphics;
import java.awt.Color;
import java.lang.RuntimeException;
import java.awt.geom.Point2D;

public class Vect_NodeConnectorCurve extends Vect_Object
{
	private Point2D.Float upperPoint;
	private Point2D.Float lowerPoint;

	public Vect_NodeConnectorCurve(Point2D.Float upperPoint, Point2D.Float lowerPoint)
		//if upperPoint.y >= lowerPoint.y
		//	throw new RuntimeException("Built connector with upper point with a y lower than that of a lower point")
	{
		this.upperPoint = upperPoint;
		this.lowerPoint = lowerPoint;
		this.depth = 1;

	}
	public void draw(Graphics g, float globalX, float globalY, float zoom, int canvasWidth, int canvasHeight)
	{
		int relativeUpperX = VectorCanvas.getRelativePositionValue(globalX, zoom, upperPoint.x);
		int relativeLowerX = VectorCanvas.getRelativePositionValue(globalX, zoom, lowerPoint.x);
		int relativeUpperY = VectorCanvas.getRelativePositionValue(globalY, zoom, upperPoint.y);
		int relativeLowerY = VectorCanvas.getRelativePositionValue(globalY, zoom, lowerPoint.y);

		if (relativeUpperX != relativeLowerX || relativeUpperY != relativeLowerY)
		{
			int minX;
			int maxX;
			if (relativeUpperX > relativeLowerX)
			{
				minX = relativeLowerX;
				maxX = relativeUpperX;
			}
			else
			{
				minX = relativeUpperX;
				maxX = relativeLowerX;

			}
			int minY;
			int maxY;
			if (relativeUpperY > relativeLowerY)
			{
				minY = relativeLowerY;
				maxY = relativeUpperY;
			}
			else
			{
				minY = relativeUpperY;
				maxY = relativeLowerY;

			}
			if (VectorCanvas.isInCanvas(canvasWidth, canvasHeight, minX, minY, maxX, maxY))
			{
				int halfWidth = maxX - minX;
				int width = halfWidth*2;
				int height = (maxY - minY)*2;
				g.setColor(Color.black);
				if (minX == relativeLowerX)
				{
					g.drawArc(minX, minY, width, height, 90, 90);
				}
				else
				{
					g.drawArc(minX - halfWidth, minY, width, height, 0, 90);
				}
				}
				}
		else
			//only one pixel to worry about here
		{
			if (VectorCanvas.isInCanvas(canvasWidth, canvasHeight, relativeLowerX, relativeLowerY))
			{
				g.setColor(Color.black);
				VectorCanvas.drawPoint(g, relativeLowerX, relativeLowerY);
			}
		}
	}
}
