/*
Created by: Nicholas Tolrud
Year: 2011
*/

import java.awt.Graphics;
import java.awt.Color;
import java.awt.geom.Point2D;
import java.awt.FontMetrics;
import java.awt.Font;

public class Vect_Text extends Vect_Object
{
	private Point2D.Float centerPoint;
	private Color color;
	private float fontSize;
	private String text;

	public Vect_Text(Point2D.Float centerPoint,  Color color, String text)
	{
		this.centerPoint = centerPoint;
		this.color = color;
		this.fontSize = 12.0f;
		this.depth = -2;
		this.text = text;

	}
	public static void setFontSize(Graphics g, float size)
	{
		Font font = g.getFont();
		Font newFont = font.deriveFont(size);
		g.setFont(newFont);

	}
	public static int getDrawnStringHeight(Graphics g)
	{
		FontMetrics fm = g.getFontMetrics();
		return fm.getHeight();

	}
	public static int getDrawnStringWidth(Graphics g, String s)
	{
		FontMetrics fm = g.getFontMetrics();
		return fm.stringWidth(s);

	}
	public static void drawCenteredString(Graphics g, String s, int x, int y, int halfDrawnStringWidth, int halfDrawnStringHeight)
	{
		FontMetrics fm = g.getFontMetrics();
		x = x - halfDrawnStringWidth;
		y = y + halfDrawnStringHeight/2;
		g.drawString(s,x,y);

	}
	public void draw(Graphics g, float globalX, float globalY, float zoom, int canvasWidth, int canvasHeight)
	{
		int relativeCenterX = VectorCanvas.getRelativePositionValue(globalX, zoom, centerPoint.x);
		int relativeCenterY = VectorCanvas.getRelativePositionValue(globalY, zoom, centerPoint.y);
		float relativeFontSize = fontSize * zoom;


		if (relativeFontSize > 1)
		{
			setFontSize(g,relativeFontSize);
			int drawnStringWidth = getDrawnStringWidth(g,text);
			int drawnStringHeight = getDrawnStringHeight(g);
			int halfDrawnStringWidth = drawnStringWidth/2;
			int halfDrawnStringHeight = drawnStringHeight/2;
			int minX = relativeCenterX - halfDrawnStringWidth;
			int minY = relativeCenterY - halfDrawnStringHeight;
			int maxX = relativeCenterX + halfDrawnStringWidth;
			int maxY = relativeCenterY + halfDrawnStringHeight;

			if (VectorCanvas.isInCanvas(canvasWidth, canvasHeight, minX, minY, maxX, maxY))
			{
				g.setColor(color);
				drawCenteredString(g, text, relativeCenterX, relativeCenterY, halfDrawnStringWidth, halfDrawnStringHeight);
			}
			}
		else if (relativeFontSize > 0)
			//only one pixel to worry about here
		{
			if (VectorCanvas.isInCanvas(canvasWidth, canvasHeight, relativeCenterX, relativeCenterY))
			{
				g.setColor(color);
				VectorCanvas.drawPoint(g, relativeCenterX, relativeCenterY);
			}
		}
	}
}
